/*!	@file
	@brief DExplore Application Objects Interface

	@author bussaba
	@date 2007/03/09 VK쐬
*/
/*
	Copyright (c) 2007, Wakura Editor Project

	This software is provided 'as-is', without any express or implied warranty.
	In no event will the authors be held liable for any damages arising from
	the use of this software.

	Permission is granted to anyone to use this software for any purpose,
	including commercial applications, and to alter it and redistribute it
	freely, subject to the following restrictions:

	    1. The origin of this software must not be misrepresented; you must not
	       claim that you wrote the original software. If you use this software
	       in a product, an acknowledgment in the product documentation would
	       be appreciated but is not required.

	    2. Altered source versions must be plainly marked as such, and must not
	       be misrepresented as being the original software.

	    3. This notice may not be removed or altered from any source
	       distribution.
*/
#ifndef VSHELP_H
#define VSHELP_H

/*
	̃t@C DExplore Ăяo߂ɕKvȃwb_t@CłB
	^CvCugpł WSH ȂȒPɎgp邱Ƃł܂
	Win32x[X炾ƊȒPɂ͗pł܂łB
	
	^CvCȕ͎ꏊɂ܂B
	C:/Program Files/Common Files/Microsoft Shared/MSEnv/vshelp.tlb
	
	̃wb_t@CC++płBCɂĂ͏ȗĂ܂B
	
	Sample source code:
	
		::CoInitialize( NULL );
		CLSID ClassID;
		if( ::CLSIDFromProgID( DExploreAppObj_Name, &ClassID ) == S_OK ){
			IHelp* pIHelp;
			//CLSCTX_LOCAL_SERVER or CLSCTX_SERVER or CLSCTX_ALL, ...
			if( ::CoCreateInstance( ClassID, NULL, CLSCTX_LOCAL_SERVER, IID_IHelp, (LPVOID)&pIHelp ) == S_OK ){
				pIHelp->SetCollection( L"ms-help://MS.PSDKSVR2003R2.1033", L"" );
				pIHelp->Contents();	//DExpore displayed!
				pIHelp->DisplayTopicFromF1Keyword( L"CoCreateInstance" );
				pIHelp->SyncIndex( L"CoCreateInstance", 1 );
				pIHelp->IndexResults();
				pIHelp->Release();	//DExplore is end!
			}
		}
		::CoUninitialize();
		
		̃R[hƎs邽тDExploreJ܂B
		łɊJĂDExploregꍇ͕ʂ̕@TKv܂B
*/

/*
	wb_t@C
*/
#include <windows.h>
#include <objbase.h>



/*
	Constant
*/
#define __vshelp_tlb_value__ 0x83285928,0x227C,0x11D3,0xB8,0x70,0x00,0xC0,0x4F,0x79,0xF8,0x02

#define __IID_IVsHelpOwner_Value__ 0xB9B0983A,0x364C,0x4866,0x87,0x3F,0xD5,0xED,0x19,0x01,0x38,0xFB
const IID IID_IVsHelpOwner = { __IID_IVsHelpOwner_Value__ };

#define __IID_IVsHelpTopicShowEvents_Value__ 0xD1AAC64A,0x6A25,0x4274,0xB2,0xC6,0xBC,0x3B,0x84,0x0B,0x6E,0x54
const IID IID_IVsHelpTopicShowEvents = { __IID_IVsHelpTopicShowEvents_Value__ };

#define __IID_IHelp_Value__ 0x4A791148,0x19E4,0x11D3,0xB8,0x6B,0x00,0xC0,0x4F,0x79,0xF8,0x02
const IID IID_IHelp = { __IID_IHelp_Value__ };

#define __IID_IVsHelpEvents_Value__ 0x507E4490,0x5A8C,0x11D3,0xB8,0x97,0x00,0xC0,0x4F,0x79,0xF8,0x02
const IID IID_IVsHelpEvents = { __IID_IVsHelpEvents_Value__ };

#define __CLSID_DExploreAppObj_Value__ 0x4A79114D,0x19E4,0x11D3,0xB8,0x6B,0x00,0xC0,0x4F,0x79,0xF8,0x02
const CLSID CLSID_DExploreAppObj = { __CLSID_DExploreAppObj_Value__ };

#define DExploreAppObj_Name L"DExplore.AppObj"



/*
	Forward Declarations

	interface IVsHelpOwner;
	interface IVsHelpTopicShowEvents;
	interface IHelp;
	interface IVsHelpEvents;
*/
#ifndef __IVsHelpOwner_FWD_DEFINED__
#define __IVsHelpOwner_FWD_DEFINED__
typedef interface IVsHelpOwner IVsHelpOwner;
#endif 	/* __IVsHelpOwner_FWD_DEFINED__ */

#ifndef __IVsHelpTopicShowEvents_FWD_DEFINED__
#define __IVsHelpTopicShowEvents_FWD_DEFINED__
typedef interface IVsHelpTopicShowEvents IVsHelpTopicShowEvents;
#endif 	/* __IVsHelpTopicShowEvents_FWD_DEFINED__ */

#ifndef __IHelp_FWD_DEFINED__
#define __IHelp_FWD_DEFINED__
typedef interface IHelp IHelp;
#endif 	/* __IHelp_FWD_DEFINED__ */

#ifndef __IVsHelpEvents_FWD_DEFINED__
#define __IVsHelpEvents_FWD_DEFINED__
typedef interface IVsHelpEvents IVsHelpEvents;
#endif 	/* __IVsHelpEvents_FWD_DEFINED__ */



/*
	IVsHelpOwner Interface
	
	B9B0983A-364C-4866-873F-D5ED190138FB
	
	version 1.0
	dual,oleautomation
*/
MIDL_INTERFACE("B9B0983A-364C-4866-873F-D5ED190138FB")
IVsHelpOwner : public IDispatch
{
public:
	//[id(0x00000001)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR BringHelpToTop(
		/* [in] */			long hwndHelpApp
		) = 0;

	//[id(0x0000000a), propget]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR AutomationObject(
		/* [out, retval] */	IDispatch __RPC_FAR *__RPC_FAR *ppObj
		) = 0;
};



/*
	IVsHelpTopicEvents Interface
	
	D1AAC64A-6A25-4274-B2C6-BC3B840B6E54
*/
MIDL_INTERFACE("D1AAC64A-6A25-4274-B2C6-BC3B840B6E54")
IVsHelpTopicShowEvents : public IDispatch
{
public:
	//_stdcall
	virtual HRESULT _stdcall __RPC_FAR OnBeforeTopicShow(
		/* [in] */			BSTR bstrURL,
		/* [in] */			IDispatch __RPC_FAR *pWB
		) = 0;

	//_stdcall
	virtual HRESULT _stdcall __RPC_FAR OnTopicShowComplete(
		/* [in] */			BSTR bstrURL,
		/* [in] */			IDispatch __RPC_FAR *pWB
		) = 0;
};



/*
	IHelp Interface
	
	4A791148-19E4-11D3-B86B-00C04F79F802
	
	dual,oleautomation
*/
MIDL_INTERFACE("4A791148-19E4-11D3-B86B-00C04F79F802")
IHelp : public IDispatch
{
public:
	//[id(0x00000001)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR Contents(
							void
		) = 0;

	//[id(0x00000002)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR Index(
							void
		) = 0;

	//[id(0x00000003)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR Search(
							void
		) = 0;

	//[id(0x00000004)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR IndexResults(
							void
		) = 0;

	//[id(0x00000005)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR SearchResults(
							void
		) = 0;

	//[id(0x00000006)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR DisplayTopicFromId(
		/* [in] */			BSTR bstrFile,
		/* [in] */			unsigned long Id
		) = 0;

	//[id(0x00000007)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR DisplayTopicFromURL(
		/* [in] */			BSTR pszURL
		) = 0;

	//[id(0x00000008)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR DisplayTopicFromURLEx(
		/* [in] */			BSTR pszURL,
		/* [in] */			IVsHelpTopicShowEvents __RPC_FAR *pIVsHelpTopicShowEvents
		) = 0;

	//[id(0x00000009)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR DisplayTopicFromKeyword(
		/* [in] */			BSTR pszKeyword
		) = 0;

	//[id(0x0000000a)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR DisplayTopicFromF1Keyword(
		/* [in] */			BSTR pszKeyword
		) = 0;

	//[id(0x0000000b)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR DisplayTopicFrom_OLD_Help(
		/* [in] */			BSTR bstrFile,
		/* [in] */			unsigned long Id
		) = 0;

	//[id(0x0000000c)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR SyncContents(
		/* [in] */			BSTR bstrURL
		) = 0;

	//[id(0x0000000d)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR CanSyncContents(
		/* [in] */			BSTR bstrURL
		) = 0;

	//[id(0x0000000e)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR GetNextTopic(
		/* [in] */			BSTR bstrURL,
		/* [out, retval] */	BSTR __RPC_FAR *pbstrNext
		) = 0;

	//[id(0x0000000f)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR GetPrevTopic(
		/* [in] */			BSTR bstrURL,
		/* [out, retval] */	BSTR __RPC_FAR *pbstrPrev
		) = 0;

	//[id(0x00000010)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR FilterUI(
							void
		) = 0;

	//[id(0x00000011)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR CanShowFilterUI(
							void
		) = 0;

	//[id(0x00000012)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR Close(
							void
		) = 0;

	//[id(0x00000013)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR SyncIndex(
		/* [in] */			BSTR bstrKeyword,
		/* [in] */			long fShow
		) = 0;

	//[id(0x00000014)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR SetCollection(
		/* [in] */			BSTR bstrCollection,
		/* [in] */			BSTR bstrFilter
		) = 0;

	//[id(0x00000015), propget]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR Collection(
		/* [out, retval] */	BSTR __RPC_FAR *pbstrCollection
		) = 0;

	//[id(0x00000016), propget]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR Filter(
		/* [out, retval] */	BSTR __RPC_FAR *pbstrFilter
		) = 0;

	//[id(0x00000016), propput]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR Filter(
		/* [in] */			BSTR pbstrFilter
		) = 0;

	//[id(0x00000017), propget]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR FilterQuery(
		/* [out, retval] */	BSTR __RPC_FAR *pbstrFilter
		) = 0;

	//[id(0x00000018), propget]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR HelpOwner(
		/* [out, retval] */	IVsHelpOwner __RPC_FAR * __RPC_FAR *ppObj
		) = 0;

	//[id(0x00000018), propput]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR HelpOwner(
		/* [in] */			IVsHelpOwner __RPC_FAR *pObj
		) = 0;

	//[id(0x00000019), propget]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR HxSession(
		/* [out, retval] */	IDispatch __RPC_FAR * __RPC_FAR *ppObj
		) = 0;

	//[id(0x0000001a), propget]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR Help(
		/* [out, retval] */	IDispatch __RPC_FAR * __RPC_FAR *ppObj
		) = 0;

	//[id(0x0000001b)]
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR GetObject(
		/* [in] */			BSTR bstrMoniker,
		/* [in] */			BSTR bstrOptions,
		/* [out, retval] */	IDispatch __RPC_FAR * __RPC_FAR *ppDisp
		) = 0;
};



/*
	IVsHelpEvents Interface
	
	507E4490-5A8C-11D3-B897-00C04F79F802
*/
MIDL_INTERFACE("507E4490-5A8C-11D3-B897-00C04F79F802")
IVsHelpEvents : public IDispatch
{
public:
	//_stdcall
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR OnFilterChanged(
		/* [in] */			BSTR bstrNewFilter
		) = 0;

	//_stdcall
	virtual HRESULT STDMETHODCALLTYPE __RPC_FAR OnCollectionChanged(
		/* [in] */			BSTR bstrNewCollection,
		/* [in] */			BSTR bstrNewFilter
		) = 0;
};



/*
	DExplore Application Objects
	
	4A79114D-19E4-11D3-B86B-00C04F79F802
	
	appobject,hidden

	coclass DExploreAppObj {
		[default] interface Help;
		[default, source] interface IVsHelpEvents;
	};
*/



#endif	//VSHELP_H
